/* Header files used by the codebase files. */

#ifndef BASE_INCLUDES_H
#define BASE_INCLUDES_H

/****************** PALM *****************/
#ifdef palmos

/* One day Palm's SDK will probably be nice and provide a complete standard
   library... */

#include <Core/System/CharAttr.h>
#include <unix_stdio.h>
#include <NetMgr.h>
#include <StringMgr.h>
#include <MemoryMgr.h>
#include <TextMgr.h>
#include <sys_socket.h>
//#include <ctype.h>
#include <sys_types.h>
#include <unix_stdarg.h>
#include <unix_string.h>
#include <unix_stdlib.h>
#include <limits.h>
#include "palmStd.h"  /* Missing functions */

#ifndef EXIT_FAILURE
#define EXIT_FAILURE -1
#endif

#ifndef EXIT_SUCCESS
#define EXIT_SUCCESS 0
#endif

#ifndef CHAR_MAX
#define CHAR_MAX 255
#endif

#define isalnum(c) ((TxtCharAttr(c) & charAttrAlNum) != 0)
#define isalpha(c) ((TxtCharAttr(c) & charAttrAlpha) != 0)
#define iscntrl(c) ((TxtCharAttr(c) & charAttrCntrl) != 0)
#define isdigit(c) ((TxtCharAttr(c) & _DI) != 0)
#define isgraph(c) ((TxtCharAttr(c) & charAttrGraph) != 0)
#define islower(c) ((TxtCharAttr(c) & _LO) != 0)
#define isprint(c) ((TxtCharAttr(c) & charAttrPrint) != 0)
#define ispunct(c) ((TxtCharAttr(c) & _PU) != 0)
#define isspace(c) ((TxtCharAttr(c) & charAttrSpace) != 0)
#define isupper(c) ((TxtCharAttr(c) & _UP) != 0)
#define isxdigit(c) ((TxtCharAttr(c) & _XD) != 0)
#define isascii(c) (((unsigned) c)<=0xff)


/* Variables */

extern Err errno;

/****************** EPOC ****************/
#elif defined(__WINS__) || defined(__EPOC32__)
#include "epocStd.h"


/****************** UNIX ****************/
#else

#include <stdio.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <string.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdarg.h>
#include <errno.h>
#include <ctype.h>
#endif 
/* End of platform definations. */


#endif /* End of BASE_INCLUDES_H */
