/** Oil filter management.
 *
 * Authors: Kristoffer Lawson, setok@kasvua.org
 * $Header: /home/sleber/cvs/liboil/filters.h,v 1.1.1.1 2003/01/06 02:09:05 sleber Exp $
 */


#ifndef FILTERS_H
#define FILTERS_H

#include <SDL/SDL.h>


/* Types */

typedef struct {
  /* Function to call when creating instance of filter. */
  SDL_Surface *(*createFunc)(SDL_Surface *originalSurface, 
			  Tcl_HashTable *options,
			  void **filterData);

  /* Function to call for rendering. */
  void (*renderFunc)(SDL_Surface *originalSurface, 
		     SDL_Surface *renderSurface, int offsetX, int offsetY,
		     void *filterData);
} Oil_Filter;


/* Functions */

void Oil_AddFilter(char *name, 
		   SDL_Surface *createFunc(SDL_Surface *originalSurface, 
					   Tcl_HashTable *options,
					   void **filterData),
		   void renderFunc(SDL_Surface *originalSurface, 
				   SDL_Surface *renderSurface,
				   int offsetX, int offsetY,
				   void *filterData));
Oil_Filter *Oil_FindFilter(char *name);
void Oil_InitFilterLib(void);

#endif
